/*
 *   NOTE: this is a machine generated file - editing not recommended
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2000-2006.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT and LICENSE for details of redistribution
 *  and use.
 *
 *  You should have received a copy of the COPYRIGHT and LICENSE file
 *  along with this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 * ----------------------------------------------------------------------------
 *
 *   Source File: F:\dte\workspace_ipv6\IPv6_newTypes_20060914\ttcn3\EtsiLibrary\LibCommon\LibCommon_BasicTypesAndValues.ttcn
 *   File       : TabularLibCommon_BasicTypesAndValues.java
 *
 *   This is a Java class providing a com.testingtech.ttcn.tci based decoding
 *   using tabular encoding information within a TTCN-3 file.
 *
 *   This file was generated by TabularCodecGenerator(version v0.2)
  *  at 21.09.2006 09:34:53
 *
 *   REVISION INFO:
 *        $Revision: 1.2 $ $Date: 2006/02/09 17:34:58 $
 * -----------------------------------------------------------------------------
 */
package com.testingtech.generated.codec.LibCommon_BasicTypesAndValues;

import com.testingtech.ttcn.tci.ExtendedTciTypeClass;
import com.testingtech.ttcn.tci.codec.base.AbstractBaseCodec;
import com.testingtech.ttcn.tci.codec.tabular.TabularDecoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularEncoder;
import com.testingtech.ttcn.tci.codec.tabular.TabularException;
import com.testingtech.ttcn.tri.TriMessageImpl;

import com.testingtech.util.BitArrayInputStream;
import com.testingtech.util.BitArrayOutputStream;

import de.tu_berlin.cs.uebb.muttcn.runtime.RB;
import de.tu_berlin.cs.uebb.muttcn.runtime.ValueImpl;

import org.etsi.ttcn.tci.Type;
import org.etsi.ttcn.tci.Value;
import org.etsi.ttcn.tri.TriMessage;


public class TabularLibCommon_BasicTypesAndValues extends AbstractBaseCodec {
    private BitArrayInputStream bis = null;

    public TabularLibCommon_BasicTypesAndValues(RB rb) {
        super(rb);
    }

    public Value decode(TriMessage rm, Type dh) {
        logDecode("TabularLibCommon_BasicTypesAndValues: entering decode");
        assert rm != null : "TriMessage should never be null";
        assert dh != null : "DecodingHyp should never be null";

        Value v = null;
        byte[] em = rm.getEncodedMessage();
        bis = new BitArrayInputStream(em);

        TabularDecoder td = new TabularDecoder(bis, RB);

        String typeName = dh.getName();
        logDecode("TabularLibCommon_BasicTypesAndValues: typeName is " +
            typeName);

        if (dh.getTypeClass() == ExtendedTciTypeClass.ANY) {
            logDecode(
                "TabularLibCommon_BasicTypesAndValues: decode(TriMessage, Type): decodingHypothesis is of typeClass ANY");

            Value theValue = dh.newInstance();

            ((ValueImpl) theValue).setPresent();
            logDecode(
                "TabularLibCommon_BasicTypesAndValues: decode(TriMessage, Type): decodingHypothesis is of typeClass ANY: theValue.getClass().getName(): " +
                theValue.getClass().getName());

            return theValue;
        }

        if (typeName.equals("octetstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("bitstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("hexstring")) {
            return super.decode(rm, dh);
        } else if (typeName.equals("charstring")) {
            return super.decode(rm, dh);
        }

        return v;
    }

    public TriMessage encode(Value val) {
        BitArrayOutputStream baos = new BitArrayOutputStream();
        TabularEncoder enc = new TabularEncoder(baos);

        String typeName = val.getType().getName();

        if (typeName.equals("octetstring")) {
            return super.encode(val);
        } else if (typeName.equals("bitstring")) {
            return super.encode(val);
        } else if (typeName.equals("charstring")) {
            return super.encode(val);
        } else if (typeName.equals("hexstring")) {
            return super.encode(val);
        }

        return null;
    }
}
