/*
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2001-2005.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT for details of redistribution and use.
 *
 *  You should have received a copy of the COPYRIGHT file along with
 *  this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 *  TESTING TECHNOLOGIES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *  SOFTWARE. IN NO EVENT SHALL TESTING TECHNOLOGIES BE LIABLE FOR ANY
 *  SPECIAL, DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 *  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 *  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 *  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 *  THIS SOFTWARE.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 *  EITHER EXPRESSED OR IMPLIED, INCLUDING ANY KIND OF IMPLIED OR
 *  EXPRESSED WARRANTY OF NON-INFRINGEMENT OR THE IMPLIED WARRANTIES
 *  OF MECHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * -----------------------------------------------------------------------------
 *
 *  AUTHOR:      dte
 *  DATE:        June 9, 2005
 *
 *  REVISION INFO:
 *    $Revision: 1.1 $ $Date: 2005/06/22 14:03:44 $
 *    $Source: /net/ttech/cvs_root/IPv6_ETSI_STF276/javasrc/com/testingtech/ttcn/tri/PTCAndRole.java,v $
 *
 * -----------------------------------------------------------------------------
 */


package com.testingtech.ttcn.tri;

import org.etsi.ttcn.tri.TriComponentId;


/**
 * Class to store the componentId and the role of the component as entry in the receive hashmap
 * 
 * @author ldte
 *
 */
public class PTCAndRole {
	private TriComponentId f_componentId = null;
	private String f_Role = "";
	
	/**
	 * The constructor of the class
	 * @param componentId	The componentId to store
	 * @param role			The role to store
	 */
	public PTCAndRole(TriComponentId componentId, String role) {
		super();
		f_componentId = componentId;
		f_Role = role;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return this.f_componentId.hashCode() + this.f_Role.hashCode();
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object niar) {
		return (this.f_componentId.equals(((PTCAndRole)niar).f_componentId) && this.f_Role.equals(((PTCAndRole)niar).f_Role));
	}
	
	/**
	 * @return Returns the f_componentId.
	 */
	public TriComponentId getComponentId() {
		return f_componentId;
	}

	/**
	 * @param componentId The f_componentId to set.
	 */
	public void setComponentId(TriComponentId componentId) {
		f_componentId = componentId;
	}

	/**
	 * @return Returns the f_Role.
	 */
	public String getRole() {
		return f_Role;
	}

	/**
	 * @param role The f_Role to set.
	 */
	public void setRole(String role) {
		f_Role = role;
	}

	/**
	 * Returns a string in the format "componentId: " + the component, "Role: " and the role.
	 */
    public String toString() {
    	return "componentId: " + f_componentId.getComponentId() + ", Role: " + f_Role + "\n";
    }
}
