/*
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2001-2007.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT for details of redistribution and use.
 *
 *  You should have received a copy of the COPYRIGHT file along with
 *  this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 *  TESTING TECHNOLOGIES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *  SOFTWARE. IN NO EVENT SHALL TESTING TECHNOLOGIES BE LIABLE FOR ANY
 *  SPECIAL, DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 *  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 *  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 *  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 *  THIS SOFTWARE.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 *  EITHER EXPRESSED OR IMPLIED, INCLUDING ANY KIND OF IMPLIED OR
 *  EXPRESSED WARRANTY OF NON-INFRINGEMENT OR THE IMPLIED WARRANTIES
 *  OF MECHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * ----------------------------------------------------------------------------
 *
 *  AUTHOR:      Dirk Tepelmann
 *  DATE:        September, 2006
 *
 *  REVISION INFO:
 *        $Revision$ $Date$
 * ----------------------------------------------------------------------------- */
package com.testingtech.ttcn.tri.enums;

public interface IEnumDefinitions {

	public final String IpSecProtocolMode_E_TRANSPORTMODE = "e_transportMode";
	public final String IpSecProtocolMode_E_TUNNELMODE = "e_tunnelMode";

	public final String ENCRYPTION_E_RESERVED = "e_reserved";
	public final String ENCRYPTION_E_DES_IV_64 = "e_encr_desIv64";
	public final String ENCRYPTION_E_DES_CBC = "e_encr_des";
	public final String ENCRYPTION_E_TRIPLEDES_CBC = "e_encr_3Des";
	public final String ENCRYPTION_E_RC5 = "e_encr_rc5";
	public final String ENCRYPTION_E_IDEA = "e_encr_idea";
	public final String ENCRYPTION_E_CAST = "e_encr_cast";
	public final String ENCRYPTION_E_BLOWFISH = "e_encr_blowfish";
	public final String ENCRYPTION_E_3IDEA = "e_encr_3Idea";
	public final String ENCRYPTION_E_DES_IV_32 = "e_encr_desIv32";
	public final String ENCRYPTION_E_NULL = "e_encr_null";
	public final String ENCRYPTION_E_AES_CBC = "e_encr_aesCbc";
	public final String ENCRYPTION_E_AES_CTR = "e_encr_aesCtr";

	public final String INTEGRITY_E_NONE ="e_none";
	public final String INTEGRITY_E_AUTH_HMACMD5_96 = "e_auth_hmacMd5_96";
	public final String INTEGRITY_E_AUTH_HMACSHA1_96 = "e_auth_hmacSha1_96";
	public final String INTEGRITY_E_AUTH_DESMAC = "e_auth_desMac";
	public final String INTEGRITY_E_AUTH_KPDKMD5 = "e_auth_kpdkMd5";
	public final String INTEGRITY_E_AUTH_AESXCBC_96 = "e_auth_aesXcbc_96";
	public final String INTEGRITY_E_AUTH_NULL = "e_auth_null";
	public final String INTEGRITY_E_AUTH_AESXCBC_MAC_96 = "e_auth_aesXcbc_mac_96";
	public final String INTEGRITY_E_AUTH_SHA1 = "e_auth_sha1";
	public final String INTEGRITY_E_AUTH_SHA1_96 = "e_auth_sha1_96";
	public final String INTEGRITY_E_AUTH_HMACSHA1_64 = "e_auth_hmacSha1_64";

	public final String PRF_E_RESERVED = "e_reserved";
	public final String PRF_E_HMAC_MD5 = "e_prfHmacMd5";
	public final String PRF_E_HMAC_SHA1 = "e_prfHmacSha1";
	public final String PRF_E_HMAC_TIGER = "e_prfHmacTiger";
	public final String PRF_E_AES_128_XCBC = "e_prfAes128Xcbc";
	
	public final String DH_E_NONE = "e_none";
	public final String DH_E_GROUP1_MODP768BIT = "e_group1ModP768Bit";
	public final String DH_E_GROUP2_MODP1024BIT = "e_group2ModP1024Bit";
	public final String DH_E_GROUP5_MODP1536BIT = "e_group5ModP1536Bit";
	public final String DH_E_GROUP14_MODP2048BIT = "e_group14ModP2048Bit";
	public final String DH_E_GROUP15_MODP3072BIT = "e_group15ModP3072Bit";
	public final String DH_E_GROUP16_MODP4096BIT = "e_group16ModP4096Bit";
	public final String DH_E_GROUP17_MODP6144BIT = "e_group17ModP6144Bit";
	public final String DH_E_GROUP18_MODP8192BIT = "e_group18ModP8192Bit";

}
